=== Domains/ParallelChemistry/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_mpi(vtkDomainsParallelChemistryCxxTests-MPI tests
  TestPSimpleBondPerceiver.cxx
  )

vtk_test_cxx_executable(vtkDomainsParallelChemistryCxxTests-MPI tests)
