=== Web/Core/Testing/Python/CMakeLists.txt ===
vtk_add_test_python(
  TestDataEncoder.py
  )

vtk_add_test_python(
  NO_DATA NO_VALID NO_OUTPUT
  TestObjectIdMap.py
  TestWebApplicationMemory.py
  )
